#!/usr/bin/env python3

import collections
import os
import re
import requests
import requests_cache

cache = os.path.basename(__file__) + '_cache'
print('Using %s as Requests download cache' % cache)
requests_cache.install_cache(cache)

url = 'https://verification.f-droid.org/'
r = requests.get(url)
jsons = set()
for line in r.content.decode().split('\n'):
    for m in re.findall(r'([^"]+\.json)"', line):
        jsons.add(m)

i = 0
verified = collections.defaultdict(set)
failed = collections.defaultdict(set)
for f in sorted(jsons):
    i += 1
    r = requests.get(url + f)
    try:
        for v in r.json().values():
            if isinstance(v, dict):
                appid = v['local']['packageName']
                if v.get('verified', False):
                    #print(f, type(r.json()), flush=True)
                    verified[appid].add(int(v['local']['versionCode']))
                else:
                    failed[appid].add(int(v['local']['versionCode']))
    except Exception as e:
        print(f, e)
for appid, v in verified.items():
    if appid not in failed:
        print(appid, v)
#import pprint
#pprint.pprint(verified)
